//------------------------------------------------------------------------
//   HD44780.      4- .
//         
//------------------------------------------------------------------------
#include "lcd.h" //     

//     
#define   E_tik     30       //    E
#define   tik_50    500      // 50    
#define   tik_2000  18000    // 2000    

void delay(unsigned long int ticks)   //    
  {
     for(; ticks; --ticks)
	    {
		asm ("nop");
	    }
  }

void lcd_pulse_E()  //  / 
  {
  delay(E_tik);
  LCD_E_SET;  //   E
  delay(E_tik);
  LCD_E_CLR;  //   E
  delay(E_tik);
  }

void lcd_send_byte(unsigned int byte) //   
  {
    if (BIT_TEST(byte,4))  LCD_D4_SET; //---------------------
    else   LCD_D4_CLR;                 //
    if (BIT_TEST(byte,5))  LCD_D5_SET; //
    else   LCD_D5_CLR;                 //
    if (BIT_TEST(byte,6))  LCD_D6_SET; //   
    else   LCD_D6_CLR;                 //
    if (BIT_TEST(byte,7))  LCD_D7_SET; //
    else   LCD_D7_CLR;                 //
  lcd_pulse_E();                       //---------------------
    if (BIT_TEST(byte,0))  LCD_D4_SET; //---------------------
    else   LCD_D4_CLR;                 //
    if (BIT_TEST(byte,1))  LCD_D5_SET; //
    else   LCD_D5_CLR;                 //   
    if (BIT_TEST(byte,2))  LCD_D6_SET; //
    else   LCD_D6_CLR;                 //
    if (BIT_TEST(byte,3))  LCD_D7_SET; //
    else   LCD_D7_CLR;                 //
  lcd_pulse_E();                       //---------------------
  }

//           
//  ,   "lcd_opros();"  ,
//  "delay(tik_50);" ,    - 
void lcd_pro_data(unsigned int date, unsigned int addr)
  {
   LCD_RW_CLR;          //   
   LCD_RS_CLR;          //  
   BIT_SET(addr,7);     //    
   lcd_send_byte(addr); // 
   delay(tik_50);         // 50    
   //lcd_opros(); //  
   LCD_RS_SET;          //  
   if (date < 10)  lcd_send_byte(date + 0x30); //  
   else   lcd_send_byte(date);                //  ( )
   delay(tik_50);// 50    
   //lcd_opros(); //  
  }

//           
//  ,   "lcd_opros();"  ,
//  "delay(3000);" ,    - 
void lcd_tek_data(unsigned int date)
  {
   LCD_RW_CLR;          //   
   LCD_RS_SET;          //  
   if (date < 10) lcd_send_byte(date + 0x30); //  
   else    lcd_send_byte(date);               //  ( )
   delay(tik_50);// 50    
   //lcd_opros(); //  
  }

void lcd_com(unsigned int comand) //    
//  ,   "lcd_opros();"  ,
//  "delay(tik_2000);" ,    - 
  {
   LCD_RW_CLR;  //   
   LCD_RS_CLR;  //  
   lcd_send_byte(comand); // 
   delay(tik_2000); // 2000    
   //lcd_opros(); //  
  }

void lcd_init() //  
  {
   lcd_com(0x28);   //4-  , 2 ,  57
   lcd_com(0x0C);   // ,  
   lcd_com(0x06);   //  ,  
   lcd_com(0x01);   // ,    
  }

void lcd_clear()  //  
  {
   lcd_com(0x01);   // ,    
  }

//         
void lcd_opros()
  {
   LCD_RW_SET;          //   
   LCD_RS_CLR;          //  
   IO1DIR_bit.P1_20=0;  //---------------------------
   IO1DIR_bit.P1_21=0;  //   
   IO1DIR_bit.P1_22=0;  // 
   IO1DIR_bit.P1_23=0;  //---------------------------
 Opros:
   delay(E_tik);       //
   LCD_E_SET;        //   E
   delay(E_tik);       //
   if (LCD_D7==ON)   //(  BUSY)    ?
     {
     delay(E_tik); //
     LCD_E_CLR;  //   E
     delay(E_tik); //
     lcd_pulse_E();  //  / 
     goto  Opros;  //
     }
   else
     {
     delay(E_tik); //
     LCD_E_CLR;  //   E
     delay(E_tik); //
     lcd_pulse_E();  //  / 
     }
   LCD_RW_CLR;          //   
   IO1DIR_bit.P1_20=1;  //---------------------------
   IO1DIR_bit.P1_21=1;  //   
   IO1DIR_bit.P1_22=1;  // 
   IO1DIR_bit.P1_23=1;  //---------------------------
   delay(E_tik);  //
   }
//-------------------------------------------------------------------











