

// 
int Open(unsigned int Flag) 
{
	//unsigned char Buffer[12];
//	unsigned char DataBuff[26];
	int rtn;
	//int i,j;
	unsigned long tmp = 0;
	//Command_Packet = &CommandBuff[0];
	/*********Open Command***********/
	Command_Packet->Head1 = COMMAND_START_CODE1;
	Command_Packet->Head2 = COMMAND_START_CODE2;
	Command_Packet->wDevId0 = DEVICE_ID;
	Command_Packet->wDevId1 = DEVICE_ID>>8;
	Command_Packet->nParam0 = Flag & 0xFF;
	Command_Packet->nParam1 = (Flag & 0xFF00) >> 8 ;
	Command_Packet->nParam2 = (Flag & 0xFF0000) >> 16;
	Command_Packet->nParam3 = (Flag & 0xFF000000) >> 24;
	Command_Packet->wCmd0 = OPEN;
	Command_Packet->wCmd1 = ZERO;
	tmp = CalcChkSumOfCmdAckPkt(Command_Packet);
	Command_Packet->wChkSum0 = tmp % 256;
	Command_Packet->wChkSum1 = tmp >> 8;
	/*********Open Command***********/

	rtn = SendCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;
	rtn = ReceiveCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	if(Command_Packet->wCmd0 != ACK)
		return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);

	rtn = CheckChkSumOfRpsAckPkt(Command_Packet);
	if(rtn != OK)
		return rtn;

	/*
        if(Flag)
	{
		rtn = ReceiveCommand((unsigned char *)Command_Packet,MASS_BUFFER);
		if(rtn == FAIL)
			return FAIL;

		rtn = CalcChkSumOfDataPkt(Command_Packet,SB_OEM_PKT_SIZE);
		if(rtn != OK)
			return rtn;
		else
		{
			memcpy(DataBuffer,Command_Packet,SB_OEM_PKT_SIZE);
		}
	}
        */
	return OK;
}





//    
int CaptureFinger(char cFlag)
{
//	SB_OEM_PKT* Command_Packet;
//	unsigned char Buffer[12];
//	unsigned char DataBuff[26];
	int rtn;
	//unsigned char i;
	unsigned long tmp = 0;
//	Command_Packet = Buffer;
	/*********Change Baudrate Command***********/
	Command_Packet->Head1 = COMMAND_START_CODE1;
	Command_Packet->Head2 = COMMAND_START_CODE2;
	Command_Packet->wDevId0 = DEVICE_ID;
	Command_Packet->wDevId1 = DEVICE_ID>>8;
	Command_Packet->nParam0 = cFlag & 0xFF;
	Command_Packet->nParam1 = (cFlag & 0xFF00) >> 8 ;
	Command_Packet->nParam2 = (cFlag & 0xFF0000) >> 16;
	Command_Packet->nParam3 = (	cFlag & 0xFF000000) >> 24;
	Command_Packet->wCmd0 = CAPTURE_FINGER;
	Command_Packet->wCmd1 = ZERO;
	tmp = CalcChkSumOfCmdAckPkt(Command_Packet);
	Command_Packet->wChkSum0 = tmp % 256;
	Command_Packet->wChkSum1 = tmp >> 8;
	/*********Change Baudrate Command***********/

	rtn = SendCommand(Command_Packet); 
	if(rtn == FAIL)
		return FAIL;

	rtn = ReceiveCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	if(Command_Packet->wCmd0 != ACK)
		return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);

	rtn = CheckChkSumOfRpsAckPkt(Command_Packet);
	if(rtn != OK)
		return rtn;

	return OK;
}


//       
int GetEnrollCount()
{
//	SB_OEM_PKT* Command_Packet;
//	unsigned char Buffer[12];
//	unsigned char DataBuff[26];
	int rtn;
	//unsigned char i;
	unsigned long tmp = 0;
//	Command_Packet = Buffer;
	/*********Change Baudrate Command***********/
	Command_Packet->Head1 = COMMAND_START_CODE1;
	Command_Packet->Head2 = COMMAND_START_CODE2;
	Command_Packet->wDevId0 = DEVICE_ID;
	Command_Packet->wDevId1 = DEVICE_ID>>8;
	Command_Packet->nParam0 = ZERO;
	Command_Packet->nParam1 = ZERO;
	Command_Packet->nParam2 = ZERO;
	Command_Packet->nParam3 = ZERO;
	Command_Packet->wCmd0 = GETENROLLCOUNT;
	Command_Packet->wCmd1 = ZERO;
	tmp = CalcChkSumOfCmdAckPkt(Command_Packet);
	Command_Packet->wChkSum0 = tmp % 256;
	Command_Packet->wChkSum1 = tmp >> 8;
	/*********Change Baudrate Command***********/

	rtn = SendCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	rtn = ReceiveCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	if(Command_Packet->wCmd0 != ACK)
		return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);

	rtn = CheckChkSumOfRpsAckPkt(Command_Packet);
	if(rtn != OK)
		return rtn;

	return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);
}

//   
int Identify()
{
//	SB_OEM_PKT* Command_Packet;
//	unsigned char Buffer[12];
//	unsigned char DataBuff[26];
	int rtn;
	//unsigned char i;
	unsigned long tmp = 0;
//	Command_Packet = Buffer;
	/*********Change Baudrate Command***********/
	Command_Packet->Head1 = COMMAND_START_CODE1;
	Command_Packet->Head2 = COMMAND_START_CODE2;
	Command_Packet->wDevId0 = DEVICE_ID;
	Command_Packet->wDevId1 = DEVICE_ID>>8;
	Command_Packet->nParam0 = ZERO;
	Command_Packet->nParam1 = ZERO;
	Command_Packet->nParam2 = ZERO;
	Command_Packet->nParam3 = ZERO;
	Command_Packet->wCmd0 = IDENTIFY;
	Command_Packet->wCmd1 = ZERO;
	tmp = CalcChkSumOfCmdAckPkt(Command_Packet);
	Command_Packet->wChkSum0 = tmp % 256;
	Command_Packet->wChkSum1 = tmp >> 8;
	/*********Change Baudrate Command***********/

	rtn = SendCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	rtn = ReceiveCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	if(Command_Packet->wCmd0 != ACK)
		return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);

	rtn = CheckChkSumOfRpsAckPkt(Command_Packet);
	if(rtn != OK)
		return rtn;

	return (Command_Packet->nParam1<<8) + Command_Packet->nParam0;
}

//   N   
int Verify(int ID)
{
//	SB_OEM_PKT* Command_Packet;
//	unsigned char Buffer[12];
//	unsigned char DataBuff[26];
	int rtn;
	//unsigned char i;
	unsigned long tmp = 0;
//	Command_Packet = Buffer;
	/*********Change Baudrate Command***********/
	Command_Packet->Head1 = COMMAND_START_CODE1;
	Command_Packet->Head2 = COMMAND_START_CODE2;
	Command_Packet->wDevId0 = DEVICE_ID;
	Command_Packet->wDevId1 = DEVICE_ID>>8;
	Command_Packet->nParam0 = ID;
	Command_Packet->nParam1 = ZERO;
	Command_Packet->nParam2 = ZERO;
	Command_Packet->nParam3 = ZERO;
	Command_Packet->wCmd0 = VERIFY;
	Command_Packet->wCmd1 = ZERO;
	tmp = CalcChkSumOfCmdAckPkt(Command_Packet);
	Command_Packet->wChkSum0 = tmp % 256;
	Command_Packet->wChkSum1 = tmp >> 8;
	/*********Change Baudrate Command***********/

	rtn = SendCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	rtn = ReceiveCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	if(Command_Packet->wCmd0 != ACK)
		return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);

	rtn = CheckChkSumOfRpsAckPkt(Command_Packet);
	if(rtn != OK)
		return rtn;

	return (Command_Packet->nParam1<<8) + Command_Packet->nParam0;
}


//   
int LED(unsigned char State)
{
//	SB_OEM_PKT* Command_Packet;
//	unsigned char Buffer[12];
//	unsigned char DataBuff[26];
	int rtn;
	//unsigned char i;
	unsigned long tmp = 0;
//	Command_Packet = Buffer;
	/*********Change Baudrate Command***********/
	Command_Packet->Head1 = COMMAND_START_CODE1;
	Command_Packet->Head2 = COMMAND_START_CODE2;
	Command_Packet->wDevId0 = DEVICE_ID;
	Command_Packet->wDevId1 = DEVICE_ID>>8;
	Command_Packet->nParam0 = State & 0xFF;
	Command_Packet->nParam1 = (State & 0xFF00) >> 8 ;
	Command_Packet->nParam2 = (State & 0xFF0000) >> 16;
	Command_Packet->nParam3 = (State & 0xFF000000) >> 24;
	Command_Packet->wCmd0 = CMOSLED;
	Command_Packet->wCmd1 = ZERO;
	tmp = CalcChkSumOfCmdAckPkt(Command_Packet);
	Command_Packet->wChkSum0 = tmp % 256;
	Command_Packet->wChkSum1 = tmp >> 8;
	/*********Change Baudrate Command***********/

	rtn = SendCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	rtn = ReceiveCommand(Command_Packet);
	if(rtn == FAIL)
		return FAIL;

	if(Command_Packet->wCmd0 != ACK)
		return Command_Packet->nParam0 + (Command_Packet->nParam1 * 256);

	rtn = CheckChkSumOfRpsAckPkt(Command_Packet);
	if(rtn != OK)
		return rtn;

	return OK;
}

